// -*- C++ -*-

#pragma once

#include "stdinc.h"
#include <complex>


namespace goopax
{
    
  namespace impl
  {

    using std::min;
    using std::max;
    
    template <typename T, typename Enable=typename goopax::impl::enable_if<(goopax::impl::is_arithmetic<T>::value && !goopax::impl::is_same<T, bool>::value)>::type>
    gpu_type<T> min(gpu_type<T> a, gpu_type<T> b);
    template <typename T, typename Enable=typename goopax::impl::enable_if<(goopax::impl::is_arithmetic<T>::value && !goopax::impl::is_same<T, bool>::value)>::type> 
    gpu_type<T> max(gpu_type<T> a, gpu_type<T> b);
  }
}

namespace goopax
{
  namespace impl
  {
      using goopax::impl::max;
      using goopax::impl::min;
      using std::isfinite;
      using std::isnormal;
      using std::isnan;
      using std::isinf;
      using std::min;
      using std::max;
      using std::abs;
      using std::floor;
      using std::ceil;
      using std::round;
      using std::log;
      using std::exp;
      using std::log2;
      using std::exp2;
      using std::sqrt;
      using std::cbrt;
      using std::sin;
      using std::cos;
      using std::tan;
      using std::asin;
      using std::acos;
      using std::atan;
      using std::sinh;
      using std::cosh;
      using std::tanh;
      using std::asinh;
      using std::acosh;
      using std::atanh;
      using std::erf;
      using std::erfc;
      using std::tgamma;
      using std::pow;
      
      using std::operator *;
      using std::operator /;
      using std::operator +;
      using std::operator -;
      using std::operator >>;
      using std::operator <<;
      //using std::operator &;
      //using std::operator |;
      //using std::operator ^;

      //      using std::operator ~;
      using std::abs;
      using std::floor;
      using std::ceil;
      using std::round;
      using std::max;
      using std::min;
  }
}

